/*
 * Project Wok
 *
 * Copyright IBM Corp, 2015-2016
 *
 * Code derived from Project Kimchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
wok.user = (function() {
    var getUserName = function() {
        return wok.cookie.get('username');
    };

    var setUserName = function(userName) {
        wok.cookie.set('username', userName, 365);
    };

    var showUser = function(toShow) {
        if (toShow) {
            var userName = getUserName();
            userName && $('#user-name').text(userName);
            $('#user-login').removeClass('not-logged-in');
            return;
        }

        $('#user-login').addClass('not-logged-in');
    };

    return {
        getUserName: getUserName,
        setUserName: setUserName,
        showUser: showUser
    };
})();
